#pragma once

class IProcessEventCallback
{
public:
	virtual void ProcessExit(DWORD ExitCode, bool Stopped) = 0;
	virtual void Progress(LPCTSTR msg, int pos, int total) = 0;
};

class CLauncher
{
public:
	CLauncher(IProcessEventCallback *callback);
	~CLauncher(void);
	BOOL Launch(const CSettings& settings, int SettingNum,
			const CString& strInput, const CString& strOutput);
	BOOL CreateStdIoPipes(HANDLE& hStdInputWrite, HANDLE& hStdInputRead,
			HANDLE& hStdOutputRead, HANDLE& hStdOutputWrite,
			HANDLE& hStdErrorRead, HANDLE& hStdErrorWrite);
	BOOL StopProcess();
	void Lock()		{::EnterCriticalSection(&m_cs);}
	void Unlock()	{::LeaveCriticalSection(&m_cs);}
	void CloseStdHandle();
	
	static DWORD WINAPI WaitProcess(LPVOID param);
	DWORD WaitProcess();
	void ParseLine(CString strLine);

	static DWORD WINAPI WaitStdError(LPVOID param);
	DWORD WaitStdError();

//	static BOOL WINAPI HandlerRoutine(DWORD dwCtrlType);

	HANDLE m_hProcess;
	DWORD m_dwProcessId;
	CRITICAL_SECTION m_cs;
	IProcessEventCallback *m_callback;
	HANDLE m_hStdInput;
	HANDLE m_hStdOutput;
	HANDLE m_hStdError;
	bool m_Stopped;
};
